GDAL-RASTER-SIEVE(1)

NAME
gdal-raster-sieve - Remove small raster polygons

Added in version 3.11.

SYNOPSIS

    Usage: gdal raster sieve [OPTIONS] <INPUT> <OUTPUT>
    Remove small polygons from a raster dataset.
    Positional arguments:
      -i, --input <INPUT>                                  Input raster datasets [required]
      -o, --output <OUTPUT>                                Output raster dataset [required]
    Common Options:
      -h, --help                                           Display help message and exit
      --json-usage                                         Display usage as JSON document and exit
      --config <KEY>=<VALUE>                               Configuration option [may be repeated]
      -q, --quiet                                          Quiet mode (no progress bar)
    Options:
      -f, --of, --format, --output-format <OUTPUT-FORMAT>  Output format ("GDALG" allowed)
      --co, --creation-option <KEY>=<VALUE>                Creation option [may be repeated]
      --overwrite                                          Whether overwriting existing output is allowed
                                                           Mutually exclusive with --append
      --append                                             Append as a subdataset to existing output
                                                           Mutually exclusive with --overwrite
      --mask <MASK>                                        Use the first band of the specified file as a validity mask (all pixels with a value other than zero will be considered suitable for inclusion in polygons)
      -b, --band <BAND>                                    Input band (1-based index)
      -s, --size-threshold <SIZE-THRESHOLD>                Minimum size of polygons to keep (default: 2)
      -c, --connect-diagonal-pixels                        Consider diagonal pixels as connected
    Advanced Options:
      --if, --input-format <INPUT-FORMAT>                  Input formats [may be repeated]
      --oo, --open-option <KEY>=<VALUE>                    Open options [may be repeated]

DESCRIPTION

gdal raster sieve removes raster polygons smaller than a provided threshold size (in pixels) and replaces them with the pixel value of the largest neighbour polygon.

The input dataset is read as integer data which means that floating point values are rounded to integers. Re-scaling source data may be necessary in some cases (e.g. 32-bit floating point data with min=0 and max=1).

This subcommand is also available as a potential step of gdal raster pipeline (since GDAL 3.12)

  Standard options

-f, --of, --format, --output-format <OUTPUT-FORMAT>
    Which output raster format to use. Allowed values may be given by gdal --formats | grep raster | grep rw | sort

--co, --creation-option <NAME>=<VALUE>
    Many formats have one or more optional creation options that can be used to control particulars about the file created. For instance, the GeoTIFF driver supports creation options to control compression, and whether the file should be tiled.

    May be repeated.

    The creation options available vary by format driver, and some simple formats have no creation options at all. A list of options supported for a format can be listed with the --formats command line option but the documentation for the format is the definitive source of information on driver creation options. See Raster drivers format specific documentation for legal creation options for each format.

--overwrite
    Allow program to overwrite existing target file or dataset. Otherwise, by default, gdal errors out if the target file or dataset already exists.

-b, --band <BAND>
    Input band (1-based index)

-s, --size-threshold <SIZE-THRESHOLD>
    Minimum size of polygons to keep (default: 2)

-c, --connect-diagonal-pixels
    Consider diagonal pixels (pixels at the corners) as connected. The default behavior is to only consider pixels that are touching the edges as connected, which is the same as 4-connectivity. When this option is selected, the algorithm will also consider pixels at the corners as connected, which is the same as 8-connectivity.

--mask <MASK>
    Use the first band of the specified file as a validity mask: all pixels in the mask band with a value other than zero will be considered suitable for inclusion in polygons.

    Added in version 3.12.

GDALG OUTPUT (ON-THE-FLY / STREAMED DATASET)

This program supports serializing the command line as a JSON file using the GDALG output format. The resulting file can then be opened as a raster dataset using the GDALG: GDAL Streamed Algorithm driver, and apply the specified pipeline in a on-the-fly / streamed way.

NOTE: However this algorithm is not natively streaming compatible. Consequently a temporary dataset will be generated, which may cause significant processing time at opening.

EXAMPLES

  Example 1: Remove polygons smaller than 10 pixels from the band 2 of a raster.

    $ gdal raster sieve -b 2 -s 10 input.tif output.tif

AUTHOR
Alessandro Pasotti <elpaso@itopen.it>

COPYRIGHT
1998-2025